grammar BoppiCore;
import BoppiCoreTokens;

program: expr EOF;

block: BLOCKOPEN ((data|let) DELIM)+ BLOCKCLOSE;

data: DATA id EQUALS BLOCKOPEN (id DELIM)+ BLOCKCLOSE;

let: LET id EQUALS expr;

id: IDENTIFIER (HASTYPE aexpr)?;

expr
    : expr expr #eApp
    | LAMBDA id expr #eAbs
    | PI id expr #eQuant
    | block expr #eDecl
    | CASE aexpr BLOCKOPEN (alt DELIM)+ BLOCKCLOSE #eCase
    | aexpr #eSimple
    ;

alt: id TO expr;

aexpr
    : id
    | literal
    | PAROPEN expr PARCLOSE
    ;

literal
    : LITERALINT
    | LITERALCHAR
    ;
